diff -ruN ../nakedmudv2.7/src/utils.h src/utils.h
--- ../nakedmudv2.7/src/utils.h	Sun Jul 31 17:13:54 2005
+++ src/utils.h	Fri Oct  7 14:15:55 2005
@@ -15,7 +15,7 @@
 //*****************************************************************************
 #define MAX_INT               214743647
 #define PI                    3.14159265
-#define e                     2.71828182
+#define MATH_E                2.71828182
 
 #define UMIN(a, b)	      ((a) < (b) ? (a) : (b))
 #ifndef MIN
@@ -62,7 +62,7 @@
 #define HESHE(ch)             (charGetSex(ch) == SEX_MALE ? "he" : \
 			       (charGetSex(ch) == SEX_FEMALE ? "she" : "it"))
 
-bool  can_see_char      ( CHAR_DATA *ch, CHAR_DATA *target);
+bool  can_see_char        ( CHAR_DATA *ch, CHAR_DATA *target);
 bool  can_see_obj         ( CHAR_DATA *ch, OBJ_DATA  *target);
 bool  can_see_exit        ( CHAR_DATA *ch, EXIT_DATA *exit);
 bool  try_enter_game      ( CHAR_DATA *ch);
@@ -75,9 +75,6 @@
 const char *see_char_as (CHAR_DATA *ch, CHAR_DATA *target);
 const char *see_obj_as  (CHAR_DATA *ch, OBJ_DATA  *target);
 
-bool  try_dialog          (CHAR_DATA *ch, CHAR_DATA *listener,const char *mssg);
-void  try_dialog_all      (CHAR_DATA *ch, LIST *listeners, const char *mssg);
-
 void     show_prompt(SOCKET_DATA *socket);
 const char *custom_prompt (CHAR_DATA *ch);
 
@@ -115,12 +112,8 @@
 void remove_keyword       (char *keywords, const char *word);
 void trim                 (char *string);
 void strip_word           (char *string, const char *word);
-int  replace_string       (char **string, const char *a, const char *b, 
-			   bool all);
-char *tag_keywords        (const char *keywords, const char *string,
+void buf_tag_keywords     (BUFFER *buf, const char *keywords,
 			   const char *start_tag, const char *end_tag);
-void format_string        (char **ptr_string, int max_width, 
-		          unsigned int maxlen, bool indent);
 int  count_letters        (const char *string, const char ch, const int strlen);
 int  count_occurences     (const char *string, const char *word);
 char *line_start          (char *string, int line);
@@ -132,29 +125,34 @@
 int string_hash           (const char *key);
 bool endswith             (const char *string, const char *end);
 bool startswith           (const char *string, const char *start);
+const char *strcpyto      (char *to, const char *from, char end);
 
 
 
 //*****************************************************************************
 // utilities for game functioning
 //*****************************************************************************
-void  extract_obj          ( OBJ_DATA *obj);
-void  extract_mobile       ( CHAR_DATA *ch );
 
-// Make sure a certain procedure is called when we are extracting an npc/char
-void  add_extract_obj_func ( void (* func)(OBJ_DATA *));
-void  add_extract_mob_func ( void (* func)(CHAR_DATA *));
+// remove the thing from the game, and delete it
+void         extract_mobile(CHAR_DATA *ch);
+void            extract_obj(OBJ_DATA  *obj);
+void           extract_room(ROOM_DATA *room);
 
 // don't call these. These are for use by gameloop.c only. Use the non-final
 // versions, please!!
-void  extract_obj_final    ( OBJ_DATA *obj);
-void  extract_mobile_final ( CHAR_DATA *ch);
+void   extract_mobile_final(CHAR_DATA *ch);
+void      extract_obj_final(OBJ_DATA  *obj);
+void     extract_room_final(ROOM_DATA *room);
 
 char *get_time             ( void );
 void  communicate          ( CHAR_DATA *dMob, char *txt, int range );
 void  load_muddata         ( void );
 CHAR_DATA  *check_reconnect( const char *player );
 
+// transfers things from one room to another
+void do_mass_transfer(ROOM_DATA *from, ROOM_DATA *to, bool chars, bool mobs, 
+		      bool objs);
+
 
 
 //*****************************************************************************
@@ -162,6 +160,41 @@
 //*****************************************************************************
 
 //
+// a function that breaks a type key into its name and locale (zone). Each key 
+// must contain its name and zone, separated by an @. For instance:
+//   sword@bobs_zone
+//
+// returns true if the name and locale were successfully found. It is assumed
+// there will be enough memory in the name and locale buffers to copy data over
+bool parse_worldkey(const char *key, char *name, char *locale);
+
+//
+// same as parse_worldkey, but if no locale is supplied, use the zone that the
+// character is currently in
+bool parse_worldkey_relative(CHAR_DATA *ch, const char *key, char *name, 
+			     char *locale);
+
+//
+// returns the locale of a key, and \0 if none exists
+const char *get_key_locale(const char *key);
+
+//
+// returns the name of a key, and \0 if none exists
+const char *get_key_name(const char *key);
+
+//
+// returns the full key of something. A full key is a name and a locale (zone
+// key) separated by an @ sign. Assumes name and locale are both valid (i.e.
+// neither have an @ sign in them).
+const char *get_fullkey(const char *name, const char *locale);
+
+//
+// returns the full key of something (name + locale), relative to the supplied
+// locale. If the key doesn't already have a locale, this function will build
+// the one supplied into the returned value.
+const char *get_fullkey_relative(const char *key, const char *locale);
+
+//
 // Returns whether or not the command matches the pattern. Patterns are just
 // like commands, except they can be terminated with *'s to signify that
 // "anything can follow at this point". Example matches might include:
@@ -177,6 +210,10 @@
 bool charHasMoreUserGroups(CHAR_DATA *ch1, CHAR_DATA *ch2);
 
 //
+// returns TRUE if the character can edit the given zone
+bool canEditZone(ZONE_DATA *zone, CHAR_DATA *ch);
+
+//
 // a function that returns the argument passed into it
 void *identity_func(void *data);
 
@@ -188,20 +225,20 @@
 
 //
 // count how many objects are in the list, that meet our critereon.
-// If name is not NULL, we search by name. Otherwise, we search by vnum.
+// If name is not NULL, we search by name. Otherwise, we search by prototype.
 // must_see TRUE, a looker must be supplied. Same thing goes for count_letters
-int   count_objs   (CHAR_DATA *looker, LIST *list, const char *name, int vnum,
-		    bool must_see);
-int   count_chars  (CHAR_DATA *looker, LIST *list, const char *name, int vnum,
-		    bool must_see);
+int   count_objs   (CHAR_DATA *looker, LIST *list, const char *name,
+		    const char *prototype, bool must_see);
+int   count_chars  (CHAR_DATA *looker, LIST *list, const char *name,
+		    const char *prototype, bool must_see);
 CHAR_DATA *find_char(CHAR_DATA *looker, LIST *list, int num, const char *name,
-		     int vnum, bool must_see);
+		     const char *prototype, bool must_see);
 OBJ_DATA *find_obj (CHAR_DATA *looker, LIST *list, int num, const char *name,
-		    int vnum, bool must_see);
-LIST *find_all_chars(CHAR_DATA *looker, LIST *list, const char *name, int vnum,
-		     bool must_see);
-LIST *find_all_objs(CHAR_DATA *looker, LIST *list, const char *name, int vnum, 
-		    bool must_see);
+		    const char *prototype, bool must_see);
+LIST *find_all_chars(CHAR_DATA *looker, LIST *list, const char *name,
+		     const char *prototype, bool must_see);
+LIST *find_all_objs(CHAR_DATA *looker, LIST *list, const char *name,
+		    const char *prototype, bool must_see);
 
 // in the various find() routines, it may sometimes arise that someone
 // wants to find multiple things (e.g. all.cookies, all.women). This is
@@ -241,12 +278,8 @@
 //
 // multi-descriptor is a pointer to the function that gets a copy of the
 // thing's description if there is more than 1 copy of it in the list.
-//
-// vnum_getter is a pointer to a function that returns the thing's vnum for
-// displaying to players of builder level and above. vnum_getter can be NULL 
-// to display no vnums.
 void show_list(CHAR_DATA *ch, LIST *list, void *descriptor, 
-	       void *multi_descriptor, void *vnum_getter);
+	       void *multi_descriptor);
 
 
 //
@@ -262,9 +295,28 @@
 
 
 //
-// returns true if the character has an object with the
-// specified vnum in his inventory. Returns false otherwise.
-// useful fo checking keys
-bool has_obj(CHAR_DATA *ch, int vnum);
+// returns true if the character has an object that is an instance of the
+// specified prototype in his inventory. Returns false otherwise.
+bool has_obj(CHAR_DATA *ch, const char *prototype);
+
+
+//
+// Delete an object, room, mobile, etc... from the game. First remove it from
+// the gameworld database, and then delete it and its contents. The onus is on
+// the builder to make sure deleting a prototype won't screw anything up (e.g.
+// people standing about in a room when it's deleted).
+bool do_delete(CHAR_DATA *ch, const char *type, void *deleter, const char *arg);
+
+
+//
+// generic xxxlist for listing all the entries of one type for a zone (e.g.
+// mprotos, oprotos, scripts...)
+void do_list(CHAR_DATA *ch, const char *locale, const char *type, 
+	     const char *header, void *informer);
+
+
+//
+// moves something of the given type with one name to the other name
+bool do_rename(CHAR_DATA *ch,const char *type,const char *from,const char *to);
 
 #endif // __UTILS_H
diff -ruN ../nakedmudv2.7/src/world.c src/world.c
--- ../nakedmudv2.7/src/world.c	Sun Jul 31 17:13:54 2005
+++ src/world.c	Fri Oct  7 14:15:55 2005
@@ -9,23 +9,17 @@
 #include <sys/stat.h>
 
 #include "mud.h"
-#include "zone.h"
-#include "room.h"
-#include "character.h"
-#include "object.h"
-#include "dialog.h"
 #include "utils.h"
+#include "zone.h"
 #include "storage.h"
+#include "prototype.h"
 #include "world.h"
 
 
 
 //*****************************************************************************
-// mandatory modules
+// defines, structures, local functions
 //*****************************************************************************
-#include "scripts/script.h"
-
-
 
 // the number of rooms we would expect, in different sized worlds
 #define SMALL_WORLD       3000
@@ -33,150 +27,89 @@
 #define LARGE_WORLD      15000
 #define HUGE_WORLD      250000
 
+typedef struct {
+  void      *(* read_func)(STORAGE_SET *);
+  STORAGE_SET     *(* store_func)(void *);
+  void            (* delete_func)(void *);
+  void (* key_func)(void *, const char *);
+} WORLD_TYPE_DATA;
 
 struct world_data {
   char            *path; // the path to our world directory
-  PROPERTY_TABLE *rooms; // this table is a communal table for rooms.
-                         // each room also has an entry in its corresponding
-                         // zone, but we also put it into this table for
-                         // quicker lookup
-  LIST *zones;
+  HASHTABLE      *rooms; // this table is a communal table for rooms. Used for
+  HASHTABLE *type_table; // types, and their functions
+  HASHTABLE      *zones; // a table of all the zones we have
 };
 
+WORLD_TYPE_DATA *newWorldTypeData(void *reader, void *storer, void *deleter,
+				  void *keysetter) {
+  WORLD_TYPE_DATA *data = malloc(sizeof(WORLD_TYPE_DATA));
+  data->read_func       = reader;
+  data->store_func      = storer;
+  data->delete_func     = deleter;
+  data->key_func        = keysetter;
+  return data;
+}
 
+void deleteWorldTypeData(WORLD_TYPE_DATA *data) {
+  free(data);
+}
 
 
-//*****************************************************************************
 //
+// transfers all of the types from the world to the zone
+void world_types_to_zone_types(WORLD_DATA *world, ZONE_DATA *zone) {
+  HASH_ITERATOR *type_i = newHashIterator(world->type_table);
+  WORLD_TYPE_DATA *type = NULL;
+  const char       *key = NULL;
+  ITERATE_HASH(key, type, type_i)
+    zoneAddType(zone, key, type->read_func, type->store_func,type->delete_func,
+		type->key_func);
+  deleteHashIterator(type_i);
+}
+
+
+
+//*****************************************************************************
 // implementation of world.h
-//
 //*****************************************************************************
-WORLD_DATA *newWorld(const char *path) {
+WORLD_DATA *newWorld(void) {
   WORLD_DATA *world = malloc(sizeof(WORLD_DATA));
-
-  world->path  = strdup(path);
-  world->zones = newList();
-  world->rooms = newPropertyTable(roomGetVnum, SMALL_WORLD);
-
+  world->type_table = newHashtable();
+  world->zones      = newHashtable();
+  world->rooms      = newHashtableSize(SMALL_WORLD);
+  world->path       = strdup("");
   return world;
-};
-
+}
 
 void deleteWorld(WORLD_DATA *world) {
-  LIST_ITERATOR *zone_i = newListIterator(world->zones);
-  ZONE_DATA *zone = NULL;
+  HASH_ITERATOR *type_i = newHashIterator(world->type_table);
+  const char       *key = NULL;
+  WORLD_TYPE_DATA *type = NULL;
+  HASH_ITERATOR *zone_i = newHashIterator(world->zones);
+  ZONE_DATA       *zone = NULL;
+
+  // delete all of our type info
+  ITERATE_HASH(key, type, type_i)
+    deleteWorldTypeData(type);
+  deleteHashIterator(type_i);
+  deleteHashtable(world->type_table);
 
   // detach ourself from all of our zones
-  ITERATE_LIST(zone, zone_i)
+  ITERATE_HASH(key, zone, zone_i)
     zoneSetWorld(zone, NULL);
-  deleteListIterator(zone_i);
+  deleteHashIterator(zone_i);
+  deleteHashtable(world->zones);
 
-  deletePropertyTable(world->rooms);
-  deleteList(world->zones);
+  deleteHashtable(world->rooms);
   free(world->path);
 
   free(world);
-};
-
-
-//
-// The generic "remove" function. "remover" is the function that
-// removes the thing from a zone.
-//
-void *worldRemoveVnum(WORLD_DATA *world, void *remover, int vnum) {
-  void *(* remove_func)(ZONE_DATA *, int) = remover;
-  LIST_ITERATOR *zone_i = newListIterator(world->zones);
-  ZONE_DATA       *zone = NULL;
-  void            *data = NULL;
-
-  // find the zone that contains our vnum
-  ITERATE_LIST(zone, zone_i) {
-    // we've found it
-    if(zoneGetMinBound(zone) <= vnum && zoneGetMaxBound(zone) >= vnum) {
-      data = remove_func(zone, vnum);
-      break;
-    }
-  }
-
-  deleteListIterator(zone_i);
-  return data;
 }
 
-
-ROOM_DATA *worldRemoveRoomVnum(WORLD_DATA *world, int vnum) {
-  propertyTableRemove(world->rooms, vnum);
-  return worldRemoveVnum(world, zoneRemoveRoom, vnum);
-};
-
-
-CHAR_DATA *worldRemoveMobVnum(WORLD_DATA *world, int vnum) {
-  return worldRemoveVnum(world, zoneRemoveMob, vnum);
-};
-
-
-OBJ_DATA *worldRemoveObjVnum(WORLD_DATA *world, int vnum) {
-  return worldRemoveVnum(world, zoneRemoveObj, vnum);
-};
-
-SCRIPT_DATA *worldRemoveScriptVnum(WORLD_DATA *world, int vnum) {
-  return worldRemoveVnum(world, zoneRemoveScript, vnum);
-};
-
-DIALOG_DATA *worldRemoveDialogVnum(WORLD_DATA *world, int vnum) {
-  return worldRemoveVnum(world, zoneRemoveDialog, vnum);
-};
-
-bool worldRemoveRoom(WORLD_DATA *world, ROOM_DATA *room) {
-  return (worldRemoveRoomVnum(world, roomGetVnum(room)) != NULL);
-};
-
-bool worldRemoveMob(WORLD_DATA *world, CHAR_DATA *mob) {
-  return (worldRemoveMobVnum(world, charGetVnum(mob)) != NULL);
-};
-
-bool worldRemoveObj(WORLD_DATA *world, OBJ_DATA *obj) {
-  return (worldRemoveObjVnum(world, objGetVnum(obj)) != NULL);
-};
-
-bool worldRemoveScript(WORLD_DATA *world, SCRIPT_DATA *script) {
-  return (worldRemoveScriptVnum(world, scriptGetVnum(script)) != NULL);
-};
-
-bool worldRemoveDialog(WORLD_DATA *world, DIALOG_DATA *dialog) {
-  return (worldRemoveDialogVnum(world, dialogGetVnum(dialog)) != NULL);
-};
-
-
-ZONE_DATA *worldRemoveZoneVnum(WORLD_DATA *world, int vnum) {
-  // go through and find our zone
-  LIST_ITERATOR *zone_i = newListIterator(world->zones);
-  ZONE_DATA *zone = NULL;
-
-  ITERATE_LIST(zone, zone_i) {
-    // we've found it
-    if(zoneGetVnum(zone) == vnum) {
-      int i;
-      // make sure we take out all rooms from this zone
-      // that we've loaded into our zone table
-      //
-      // eventually, will we have to do this for obj and mob protos, too?
-      for(i = zoneGetMinBound(zone); i <= zoneGetMaxBound(zone); i++)
-	propertyTableRemove(world->rooms, i);
-      break;
-    }
-  }
-
-  deleteListIterator(zone_i);
-  if(zone)
-    zoneSetWorld(zone, NULL);
-  return zone;
-};
-
-
-bool worldRemoveZone(WORLD_DATA *world, ZONE_DATA *zone) {
-  return (worldRemoveZoneVnum(world, zoneGetVnum(zone)) != NULL);
-};
-
+ZONE_DATA *worldRemoveZone(WORLD_DATA *world, const char *key) {
+  return hashRemove(world->zones, key);
+}
 
 bool worldSave(WORLD_DATA *world, const char *dirpath) {
   char buf[MAX_BUFFER];
@@ -184,18 +117,18 @@
   STORAGE_SET_LIST *list = new_storage_list();
   store_list(set, "zones", list);
 
-  LIST_ITERATOR *zone_i = newListIterator(world->zones);
+  HASH_ITERATOR *zone_i = newHashIterator(world->zones);
+  const char       *key = NULL;
   ZONE_DATA       *zone = NULL;
   // save each zone to its own directory, and also put
   // its number in the save file for the zone list
-  ITERATE_LIST(zone, zone_i) {
+  ITERATE_HASH(key, zone, zone_i) {
     if(zoneSave(zone)) {
       STORAGE_SET *zone_set = new_storage_set();
-      store_int(zone_set, "vnum", zoneGetVnum(zone));
+      store_string(zone_set, "key", zoneGetKey(zone));
       storage_list_put(list, zone_set);
     }
-  }
-  deleteListIterator(zone_i);
+  } deleteHashIterator(zone_i);
 
   sprintf(buf, "%s/world", dirpath);
   storage_write(set, buf);
@@ -204,10 +137,9 @@
 }
 
 
-WORLD_DATA *worldLoad(const char *dirpath) {
-  WORLD_DATA      *world = newWorld(dirpath);
+void worldInit(WORLD_DATA *world) {
   char buf[MAX_BUFFER];
-  sprintf(buf, "%s/world", dirpath);
+  sprintf(buf, "%s/world", world->path);
 
   STORAGE_SET       *set = storage_read(buf);
   STORAGE_SET_LIST *list = read_list(set, "zones");
@@ -215,300 +147,173 @@
 
   while( (zone_set = storage_list_next(list)) != NULL) {
     ZONE_DATA *zone = NULL;
-    int        vnum = read_int(zone_set, "vnum");
-    if(zoneIsOldFormat(world, vnum))
-      zone = zoneLoadOld(world, vnum);
-    else
-      zone = zoneLoad(world, vnum);
+    const char *key = read_string(zone_set, "key");
+    zone = zoneLoad(world, key);
 
-    if(zone != NULL)
-      listPut(world->zones, zone);
+    if(zone != NULL) {
+      hashPut(world->zones, key, zone);
+      world_types_to_zone_types(world, zone);
+    }
   }
   storage_close(set);
-
-  return world;
 }
 
 void worldPulse(WORLD_DATA *world) {
-  LIST_ITERATOR *zone_i = newListIterator(world->zones);
-  ZONE_DATA *zone;
+  HASH_ITERATOR *zone_i = newHashIterator(world->zones);
+  const char       *key = NULL;
+  ZONE_DATA       *zone = NULL;
 
-  ITERATE_LIST(zone, zone_i)
+  ITERATE_HASH(key, zone, zone_i)
     zonePulse(zone);
-  deleteListIterator(zone_i);
+  deleteHashIterator(zone_i);
 }
 
 void worldForceReset(WORLD_DATA *world) {
-  LIST_ITERATOR *zone_i = newListIterator(world->zones);
-  ZONE_DATA *zone;
+  HASH_ITERATOR *zone_i = newHashIterator(world->zones);
+  const char       *key = NULL;
+  ZONE_DATA       *zone = NULL;
 
-  ITERATE_LIST(zone, zone_i)
+  ITERATE_HASH(key, zone, zone_i)
     zoneForceReset(zone);
-  deleteListIterator(zone_i);
+  deleteHashIterator(zone_i);
 }
 
 
 
 //*****************************************************************************
-//
 // set and get functions
-//
 //*****************************************************************************
+LIST *worldGetZoneKeys(WORLD_DATA *world) {
+  LIST            *keys = newList();
+  HASH_ITERATOR *zone_i = newHashIterator(world->zones);
+  const char       *key = NULL;
+  ZONE_DATA       *zone = NULL;
 
-//
-// Search through all of the zones in this world, and return the one
-// that has min/max vnums that bound this vnum
-//
-ZONE_DATA *worldZoneBounding(WORLD_DATA *world, int vnum) {
-  LIST_ITERATOR *zone_i = newListIterator(world->zones);
-  ZONE_DATA *zone = NULL;
-
-  ITERATE_LIST(zone, zone_i)
-    if(zoneGetMinBound(zone) <= vnum && zoneGetMaxBound(zone) >= vnum)
-      break;
-
-  deleteListIterator(zone_i);
-  return zone;
-};
-
-LIST *worldGetZones(WORLD_DATA *world) {
-  return world->zones;
+  ITERATE_HASH(key, zone, zone_i)
+    listQueue(keys, strdup(key));
+  deleteHashIterator(zone_i);
+  return keys;
 }
 
-ZONE_DATA  *worldGetZone(WORLD_DATA *world, int vnum) {
-  LIST_ITERATOR *zone_i = newListIterator(world->zones);
-  ZONE_DATA *zone = NULL;
-  bool zone_found = FALSE;
-
-  ITERATE_LIST(zone, zone_i) {
-    if(zoneGetVnum(zone) == vnum) {
-      zone_found = TRUE;
-      break;
-    }
-  } deleteListIterator(zone_i);
-
-  return (zone_found ? zone : NULL);
-};
-
-const char *worldGetZonePath(WORLD_DATA *world, int vnum) {
+const char *worldGetZonePath(WORLD_DATA *world, const char *key) {
   static char buf[SMALL_BUFFER];
-  sprintf(buf, "%s/%d", world->path, vnum);
+  sprintf(buf, "%s/%s", world->path, key);
   return buf;
 }
 
-//
-// The generic world "get". getter must be the function that
-// needs to be used to get the thing we want to get from a zone.
-//
-void *worldGet(WORLD_DATA *world, void *getter, int vnum) {
-  void *(* get_func)(ZONE_DATA *, int) = getter;
-
-  LIST_ITERATOR *zone_i = newListIterator(world->zones);
-  ZONE_DATA       *zone = NULL;
-  void            *data = NULL;
+const char *worldGetPath(WORLD_DATA *world) {
+  return world->path;
+}
 
-  // find the zone that contains our vnum
-  ITERATE_LIST(zone, zone_i) {
-    // we've found it
-    if(zoneGetMinBound(zone) <= vnum && zoneGetMaxBound(zone) >= vnum) {
-      data = get_func(zone, vnum);
-      break;
+void worldSetPath(WORLD_DATA *world, const char *path) {
+  if(world->path) free(world->path);
+  world->path    = strdupsafe(path);
+}
+
+void worldPutRoom(WORLD_DATA *world, const char *key, ROOM_DATA *room) {
+  hashPut(world->rooms, key, room);
+}
+
+ROOM_DATA *worldGetRoom(WORLD_DATA *world, const char *key) {
+  ROOM_DATA *room = NULL;
+  // see if we have it in the room hashtable
+  if( (room = hashGet(world->rooms, key)) == NULL) {
+    char name[SMALL_BUFFER], locale[SMALL_BUFFER];
+    if(parse_worldkey(key, name, locale)) {
+      ZONE_DATA *zone = hashGet(world->zones, locale);
+      if(zone != NULL) {
+	PROTO_DATA *rproto = zoneGetType(zone, "rproto", name);
+	if(rproto != NULL && (room = protoRoomRun(rproto)) != NULL)
+	  worldPutRoom(world, protoGetKey(rproto), room);
+      }
     }
   }
-  deleteListIterator(zone_i);
-  return data;
-}
-
-ROOM_DATA  *worldGetRoom(WORLD_DATA *world, int vnum) {
-  ROOM_DATA *room = worldGet(world, zoneGetRoom, vnum);
-  // if it exists, we might as well toss it
-  // into the global table for future reference
-  if(room != NULL)
-    propertyTablePut(world->rooms, room);
   return room;
-};
-
-CHAR_DATA  *worldGetMob(WORLD_DATA *world, int vnum) {
-  return worldGet(world, zoneGetMob, vnum);
-};
-
-OBJ_DATA  *worldGetObj(WORLD_DATA *world, int vnum) {
-  return worldGet(world, zoneGetObj, vnum);
-};
-
-SCRIPT_DATA  *worldGetScript(WORLD_DATA *world, int vnum) {
-  return worldGet(world, zoneGetScript, vnum);
-};
-
-DIALOG_DATA  *worldGetDialog(WORLD_DATA *world, int vnum) {
-  return worldGet(world, zoneGetDialog, vnum);
-};
-
-
-//
-// generic function for saving something to disk
-bool worldSaveThing(WORLD_DATA *world, void *zone_save_func, void *thing, 
-		    int vnum) {
-  void (* saver)(ZONE_DATA *zone, void *thing) = zone_save_func;
-  ZONE_DATA *zone = worldZoneBounding(world, vnum);
-  if(zone == NULL)
-    return FALSE;
-  else {
-    saver(zone, thing);
-    return TRUE;
-  }
-}
-
-bool worldSaveRoom(WORLD_DATA *world, ROOM_DATA *room) {
-  return worldSaveThing(world, zoneSaveRoom, room, roomGetVnum(room));
 }
 
-bool worldSaveMob(WORLD_DATA *world, CHAR_DATA *ch) {
-  return worldSaveThing(world, zoneSaveMob, ch, charGetVnum(ch));
-}
-
-bool worldSaveObj(WORLD_DATA *world, OBJ_DATA *obj) {
-  return worldSaveThing(world, zoneSaveObj, obj, objGetVnum(obj));
-}
-
-bool worldSaveScript(WORLD_DATA *world, SCRIPT_DATA *script) {
-    return worldSaveThing(world, zoneSaveScript, script, scriptGetVnum(script));
+ROOM_DATA *worldRemoveRoom(WORLD_DATA *world, const char *key) {
+  ROOM_DATA *room = hashRemove(world->rooms, key);
+  return room;
 }
 
-bool worldSaveDialog(WORLD_DATA *world, DIALOG_DATA *dialog) {
-    return worldSaveThing(world, zoneSaveDialog, dialog, dialogGetVnum(dialog));
+bool worldRoomLoaded(WORLD_DATA *world, const char *key) {
+  return hashIn(world->rooms, key);
 }
 
-
 void worldPutZone(WORLD_DATA *world, ZONE_DATA *zone) {
-  LIST_ITERATOR *zone_i = newListIterator(world->zones);
-  ZONE_DATA *tmpzone = NULL;
-
-  // make sure there are no conflicts with other zones ...
-  ITERATE_LIST(tmpzone, zone_i) {
-    // do our ranges overlap at all?
-    if( (zoneGetMinBound(tmpzone) >= zoneGetMinBound(zone) &&
-	 zoneGetMinBound(tmpzone) <= zoneGetMaxBound(zone))   ||
-	(zoneGetMaxBound(tmpzone) >= zoneGetMinBound(zone) &&
-	 zoneGetMaxBound(tmpzone) <= zoneGetMaxBound(zone))) {
-      log_string("ERROR: tried to add new zone %d, but its range overlapped "
-		 "with zone %d!", zoneGetVnum(zone), zoneGetVnum(tmpzone));
-      return;
-    }
-    // do we have the same vnum?
-    else if(zoneGetVnum(zone) == zoneGetVnum(tmpzone)) {
-      log_string("ERROR: tried to add new zone %d, but the world already has "
-		 "a zone with that vnum!", zoneGetVnum(zone));
-      return;
-    }
+  // make sure there are no conflicts with other zones...
+  if(hashIn(world->zones, zoneGetKey(zone))) {
+    log_string("ERROR: tried to add new zone %s, but the world already has "
+	       "a zone with that key!", zoneGetKey(zone));
+    return;
   }
-  deleteListIterator(zone_i);
-
-  // make our directory and subdirectories
-  char buf[MAX_BUFFER];
-  mkdir(worldGetZonePath(world, zoneGetVnum(zone)), S_IRWXU | S_IRWXG);
-  sprintf(buf, "%s/room", worldGetZonePath(world, zoneGetVnum(zone)));
-  mkdir(buf, S_IRWXU | S_IRWXG);
-  sprintf(buf, "%s/mob", worldGetZonePath(world, zoneGetVnum(zone)));
-  mkdir(buf, S_IRWXU | S_IRWXG);
-  sprintf(buf, "%s/obj", worldGetZonePath(world, zoneGetVnum(zone)));
-  mkdir(buf, S_IRWXU | S_IRWXG);
-  sprintf(buf, "%s/dialog", worldGetZonePath(world, zoneGetVnum(zone)));
-  mkdir(buf, S_IRWXU | S_IRWXG);
-  sprintf(buf, "%s/script", worldGetZonePath(world, zoneGetVnum(zone)));
-  mkdir(buf, S_IRWXU | S_IRWXG);
 
-  listPut(world->zones, zone);
+  // connect the world and zone
+  hashPut(world->zones, zoneGetKey(zone), zone);
   zoneSetWorld(zone, world);
-};
-
 
-//
-// The generic world "put". putter must be the function that
-// needs to be used to put the thing we want to put into a zone.
-// return true if successful, and false otherwise
-//
-void worldPut(WORLD_DATA *world, void *putter, void *data, int vnum) {
-  void *(* put_func)(ZONE_DATA *, void *) = putter;
+  // make the zone's directory
+  mkdir(worldGetZonePath(world, zoneGetKey(zone)), S_IRWXU | S_IRWXG);
 
-  ZONE_DATA *zone = worldZoneBounding(world, vnum);
-  // we have no zone for this thing ... don't add it
-  if(zone != NULL)
-    put_func(zone, data);
+  // add in all of our type functions, which will create dirs as needed
+  world_types_to_zone_types(world, zone);
 }
 
-void worldPutRoom(WORLD_DATA *world, ROOM_DATA *room) {
-  worldPut(world, zoneAddRoom, room, roomGetVnum(room));
-};
-
-void worldPutMob(WORLD_DATA *world, CHAR_DATA *mob) {
-  worldPut(world, zoneAddMob, mob, charGetVnum(mob));
-};
-
-void worldPutObj(WORLD_DATA *world, OBJ_DATA *obj) {
-  worldPut(world, zoneAddObj, obj, objGetVnum(obj));
-};
 
-void worldPutScript(WORLD_DATA *world, SCRIPT_DATA *script) {
-  worldPut(world, zoneAddScript, script, scriptGetVnum(script));
-};
-
-void worldPutDialog(WORLD_DATA *world, DIALOG_DATA *dialog) {
-  worldPut(world, zoneAddDialog, dialog, dialogGetVnum(dialog));
-};
-
-bool worldIsThingLoaded(WORLD_DATA *world, 
-			bool (* checker)(ZONE_DATA *, int), int vnum) {
-  ZONE_DATA *zone = worldZoneBounding(world, vnum);
-  if(zone == NULL)
-    return FALSE;
-  else
-    return checker(zone, vnum);
-}
 
-bool worldIsRoomLoaded(WORLD_DATA *world, int vnum) {
-  return worldIsThingLoaded(world, zoneIsRoomLoaded, vnum);
-}
-
-bool worldIsMobLoaded(WORLD_DATA *world, int vnum) {
-  return worldIsThingLoaded(world, zoneIsMobLoaded, vnum);
-}
-
-bool worldIsObjLoaded(WORLD_DATA *world, int vnum) {
-  return worldIsThingLoaded(world, zoneIsObjLoaded, vnum);
-}
-
-bool worldIsScriptLoaded(WORLD_DATA *world, int vnum) {
-  return worldIsThingLoaded(world, zoneIsScriptLoaded, vnum);
-}
-
-bool worldIsDialogLoaded(WORLD_DATA *world, int vnum) {
-  return worldIsThingLoaded(world, zoneIsDialogLoaded, vnum);
-}
-
-void worldUnloadThing(WORLD_DATA *world,
-		      void (* unloader)(ZONE_DATA *, int), int vnum) {
-  ZONE_DATA *zone = worldZoneBounding(world, vnum);
-  if(zone != NULL)
-    unloader(zone, vnum);  
-}
-
-void worldUnloadRoom(WORLD_DATA *world, int vnum) {
-  worldUnloadThing(world, zoneUnloadRoom, vnum);
+//*****************************************************************************
+// implementation of the new world interface
+//*****************************************************************************
+void *worldGetType(WORLD_DATA *world, const char *type, const char *key) {
+  char name[SMALL_BUFFER], locale[SMALL_BUFFER];
+  ZONE_DATA *zone = NULL;
+  if(parse_worldkey(key, name, locale) && 
+     (zone = hashGet(world->zones, locale)) != NULL)
+    return zoneGetType(zone, type, name);
+  return NULL;
 }
 
-void worldUnloadMob(WORLD_DATA *world, int vnum) {
-  worldUnloadThing(world, zoneUnloadMob, vnum);
+void *worldRemoveType(WORLD_DATA *world, const char *type, const char *key) {
+  char name[SMALL_BUFFER], locale[SMALL_BUFFER];
+  ZONE_DATA *zone = NULL;
+  if(parse_worldkey(key, name, locale) && 
+     (zone = hashGet(world->zones, locale)) != NULL)
+    return zoneRemoveType(zone, type, name);
+  return NULL;
 }
 
-void worldUnloadObj(WORLD_DATA *world, int vnum) {
-  worldUnloadThing(world, zoneUnloadObj, vnum);
+void worldSaveType(WORLD_DATA *world, const char *type, const char *key) {
+  char name[SMALL_BUFFER], locale[SMALL_BUFFER];
+  ZONE_DATA *zone = NULL;
+  if(parse_worldkey(key, name, locale) && 
+     (zone = hashGet(world->zones, locale)) != NULL)
+    zoneSaveType(zone, type, name);
 }
 
-void worldUnloadScript(WORLD_DATA *world, int vnum) {
-  worldUnloadThing(world, zoneUnloadScript, vnum);
+void worldPutType(WORLD_DATA *world, const char *type, const char *key,
+		  void *data) {
+  char name[SMALL_BUFFER], locale[SMALL_BUFFER];
+  ZONE_DATA *zone = NULL;
+  if(parse_worldkey(key, name, locale) && 
+     (zone = hashGet(world->zones, locale)) != NULL)
+    zonePutType(zone, type, name, data);
+}
+
+void worldAddType(WORLD_DATA *world, const char *type, void *reader,
+		  void *storer, void *deleter, void *zonesetter) {
+  // add the new type to each of our zones, too
+  if(!hashIn(world->type_table, type)) {
+    hashPut(world->type_table, type, 
+	    newWorldTypeData(reader, storer, deleter, zonesetter));
+    HASH_ITERATOR *zone_i = newHashIterator(world->zones);
+    const char       *key = NULL;
+    ZONE_DATA       *zone = NULL;
+    ITERATE_HASH(key, zone, zone_i)
+      zoneAddType(zone, type, reader, storer, deleter, zonesetter);
+    deleteHashIterator(zone_i);
+  }
 }
 
-void worldUnloadDialog(WORLD_DATA *world, int vnum) {
-  worldUnloadThing(world, zoneUnloadDialog, vnum);
+ZONE_DATA *worldGetZone(WORLD_DATA *world, const char *key) {
+  return hashGet(world->zones, key);
 }
